/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package saxdemo;

import java.io.File;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

/**
 *
 * @author Ludek Bartek
 * @version March 2016
 */
public class SAXDemo extends DefaultHandler{

    private int elementsCount = 0;
    private int documentsCount = 0;
    private int attributesCount = 0;


    @Override
    public void startDocument() throws SAXException {
        documentsCount++;
    }

    @Override
    public void startElement(String uri, String localName, String qName, Attributes atts) throws SAXException {
        elementsCount++;
        for(int i = 0 ; i < atts.getLength() ; i++ ){
            attributesCount++;
        }
    }

    public int getElementsCount() {
        return elementsCount;
    }

    public int getAttributesCount() {
        return attributesCount;
    }

    public int getDocumentsCount() {
        return documentsCount;
    }


    
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        try {
            SAXDemo saxSample = new SAXDemo();
            SAXParserFactory spf = SAXParserFactory.newInstance();
            SAXParser sp = spf.newSAXParser();
            sp.parse(new File(args[0]), saxSample);
            System.out.println(String.format("Soubor %s obsahuje %d dokument(u), %d elementu a %d atributu.", args[0],
                    saxSample.getDocumentsCount(),saxSample.getElementsCount(),
                    saxSample.getAttributesCount()));
        } catch (IOException | ParserConfigurationException | SAXException ex) {
            Logger.getLogger(SAXDemo.class.getName()).log(Level.SEVERE, "Chyba pri analyze dokumentu.", ex);
        }
    }
    
}
